package cn.iocoder.yudao.module.iot.service.alertrecord;

import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import javax.annotation.Resource;

import cn.iocoder.yudao.framework.test.core.ut.BaseDbUnitTest;

import cn.iocoder.yudao.module.iot.controller.admin.alertrecord.vo.*;
import cn.iocoder.yudao.module.iot.dal.dataobject.alertrecord.AlertRecordDO;
import cn.iocoder.yudao.module.iot.dal.mysql.alertrecord.AlertRecordMapper;
import cn.iocoder.yudao.framework.common.pojo.PageResult;

import org.springframework.context.annotation.Import;

import static cn.iocoder.yudao.module.iot.enums.ErrorCodeConstants.*;
import static cn.iocoder.yudao.framework.test.core.util.AssertUtils.*;
import static cn.iocoder.yudao.framework.test.core.util.RandomUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.LocalDateTimeUtils.*;
import static cn.iocoder.yudao.framework.common.util.object.ObjectUtils.*;
import static org.junit.jupiter.api.Assertions.*;

/**
 * {@link AlertRecordServiceImpl} 的单元测试类
 *
 * @author 内蒙必硕
 */
@Import(AlertRecordServiceImpl.class)
public class AlertRecordServiceImplTest extends BaseDbUnitTest {

    @Resource
    private AlertRecordServiceImpl alertRecordService;

    @Resource
    private AlertRecordMapper alertRecordMapper;

    @Test
    public void testCreateAlertRecord_success() {
        // 准备参数
        AlertRecordSaveReqVO createReqVO = randomPojo(AlertRecordSaveReqVO.class).setId(null);

        // 调用
        Long alertRecordId = alertRecordService.createAlertRecord(createReqVO);
        // 断言
        assertNotNull(alertRecordId);
        // 校验记录的属性是否正确
        AlertRecordDO alertRecord = alertRecordMapper.selectById(alertRecordId);
        assertPojoEquals(createReqVO, alertRecord, "id");
    }

    @Test
    public void testUpdateAlertRecord_success() {
        // mock 数据
        AlertRecordDO dbAlertRecord = randomPojo(AlertRecordDO.class);
        alertRecordMapper.insert(dbAlertRecord);// @Sql: 先插入出一条存在的数据
        // 准备参数
        AlertRecordSaveReqVO updateReqVO = randomPojo(AlertRecordSaveReqVO.class, o -> {
            o.setId(dbAlertRecord.getId()); // 设置更新的 ID
        });

        // 调用
        alertRecordService.updateAlertRecord(updateReqVO);
        // 校验是否更新正确
        AlertRecordDO alertRecord = alertRecordMapper.selectById(updateReqVO.getId()); // 获取最新的
        assertPojoEquals(updateReqVO, alertRecord);
    }

    @Test
    public void testUpdateAlertRecord_notExists() {
        // 准备参数
        AlertRecordSaveReqVO updateReqVO = randomPojo(AlertRecordSaveReqVO.class);

        // 调用, 并断言异常
        assertServiceException(() -> alertRecordService.updateAlertRecord(updateReqVO), ALERT_RECORD_NOT_EXISTS);
    }

    @Test
    public void testDeleteAlertRecord_success() {
        // mock 数据
        AlertRecordDO dbAlertRecord = randomPojo(AlertRecordDO.class);
        alertRecordMapper.insert(dbAlertRecord);// @Sql: 先插入出一条存在的数据
        // 准备参数
        Long id = dbAlertRecord.getId();

        // 调用
        alertRecordService.deleteAlertRecord(id);
       // 校验数据不存在了
       assertNull(alertRecordMapper.selectById(id));
    }

    @Test
    public void testDeleteAlertRecord_notExists() {
        // 准备参数
        Long id = randomLongId();

        // 调用, 并断言异常
        assertServiceException(() -> alertRecordService.deleteAlertRecord(id), ALERT_RECORD_NOT_EXISTS);
    }

    @Test
    @Disabled  // TODO 请修改 null 为需要的值，然后删除 @Disabled 注解
    public void testGetAlertRecordPage() {
       // mock 数据
       AlertRecordDO dbAlertRecord = randomPojo(AlertRecordDO.class, o -> { // 等会查询到
           o.setAlertCode(null);
           o.setAlertName(null);
           o.setAlertType(null);
           o.setAlertLevel(null);
           o.setContent(null);
           o.setConditionInfo(null);
           o.setConditionFormula(null);
           o.setDataValue(null);
           o.setDataType(null);
           o.setDataUnit(null);
           o.setDataTypeRemark(null);
           o.setCreateTime(null);
           o.setAlertId(null);
           o.setAlertAudio(null);
           o.setIsRepeat(null);
           o.setNoRepeatDuration(null);
           o.setDataId(null);
           o.setDataCode(null);
           o.setDataName(null);
       });
       alertRecordMapper.insert(dbAlertRecord);
       // 测试 alertCode 不匹配
       alertRecordMapper.insert(cloneIgnoreId(dbAlertRecord, o -> o.setAlertCode(null)));
       // 测试 alertName 不匹配
       alertRecordMapper.insert(cloneIgnoreId(dbAlertRecord, o -> o.setAlertName(null)));
       // 测试 alertType 不匹配
       alertRecordMapper.insert(cloneIgnoreId(dbAlertRecord, o -> o.setAlertType(null)));
       // 测试 alertLevel 不匹配
       alertRecordMapper.insert(cloneIgnoreId(dbAlertRecord, o -> o.setAlertLevel(null)));
       // 测试 content 不匹配
       alertRecordMapper.insert(cloneIgnoreId(dbAlertRecord, o -> o.setContent(null)));
       // 测试 condition 不匹配
       alertRecordMapper.insert(cloneIgnoreId(dbAlertRecord, o -> o.setConditionInfo(null)));
       // 测试 conditionFormula 不匹配
       alertRecordMapper.insert(cloneIgnoreId(dbAlertRecord, o -> o.setConditionFormula(null)));
       // 测试 dataValue 不匹配
       alertRecordMapper.insert(cloneIgnoreId(dbAlertRecord, o -> o.setDataValue(null)));
       // 测试 dataType 不匹配
       alertRecordMapper.insert(cloneIgnoreId(dbAlertRecord, o -> o.setDataType(null)));
       // 测试 dataUnit 不匹配
       alertRecordMapper.insert(cloneIgnoreId(dbAlertRecord, o -> o.setDataUnit(null)));
       // 测试 dataTypeRemark 不匹配
       alertRecordMapper.insert(cloneIgnoreId(dbAlertRecord, o -> o.setDataTypeRemark(null)));
       // 测试 createTime 不匹配
       alertRecordMapper.insert(cloneIgnoreId(dbAlertRecord, o -> o.setCreateTime(null)));
       // 测试 alertId 不匹配
       alertRecordMapper.insert(cloneIgnoreId(dbAlertRecord, o -> o.setAlertId(null)));
       // 测试 alertAudio 不匹配
       alertRecordMapper.insert(cloneIgnoreId(dbAlertRecord, o -> o.setAlertAudio(null)));
       // 测试 isRepeat 不匹配
       alertRecordMapper.insert(cloneIgnoreId(dbAlertRecord, o -> o.setIsRepeat(null)));
       // 测试 noRepeatDuration 不匹配
       alertRecordMapper.insert(cloneIgnoreId(dbAlertRecord, o -> o.setNoRepeatDuration(null)));
       // 测试 dataId 不匹配
       alertRecordMapper.insert(cloneIgnoreId(dbAlertRecord, o -> o.setDataId(null)));
       // 测试 dataCode 不匹配
       alertRecordMapper.insert(cloneIgnoreId(dbAlertRecord, o -> o.setDataCode(null)));
       // 测试 dataName 不匹配
       alertRecordMapper.insert(cloneIgnoreId(dbAlertRecord, o -> o.setDataName(null)));
       // 准备参数
       AlertRecordPageReqVO reqVO = new AlertRecordPageReqVO();
       reqVO.setAlertCode(null);
       reqVO.setAlertName(null);
       reqVO.setAlertType(null);
       reqVO.setAlertLevel(null);
       reqVO.setContent(null);
       //reqVO.setCondition(null);
       reqVO.setConditionFormula(null);
       reqVO.setDataValue(null);
       reqVO.setDataType(null);
       reqVO.setDataUnit(null);
       reqVO.setDataTypeRemark(null);
       reqVO.setCreateTime(buildBetweenTime(2023, 2, 1, 2023, 2, 28));
       reqVO.setAlertId(null);
       reqVO.setAlertAudio(null);
       reqVO.setIsRepeat(null);
       reqVO.setNoRepeatDuration(null);
       reqVO.setDataId(null);
       reqVO.setDataCode(null);
       reqVO.setDataName(null);

       // 调用
       PageResult<AlertRecordDO> pageResult = alertRecordService.getAlertRecordPage(reqVO);
       // 断言
       assertEquals(1, pageResult.getTotal());
       assertEquals(1, pageResult.getList().size());
       assertPojoEquals(dbAlertRecord, pageResult.getList().get(0));
    }

}